function dist = ssDist(U1,U2)
% Distance between subspaces using subspace affinity
%   dist = ssDist(U1,U2)
% Input:
%   U1: basis for first subspace
%   U2: basis for second subspace
% Output:
%   dist: distance between subspaces
%--------------------------------------------------------------------------
% Copyright @ John Lipor, 2020
%--------------------------------------------------------------------------

[D,d] = size(U1);
dist = abs(sqrt(1 - norm(U1'*U2,'fro')^2 / d));
