function Dmat = ssPdist(X,d,estLabels,state)

[D,N] = size(X);
K = max(estLabels);

ipMat = zeros(N);
if nargin < 4
    % get subspace basis for each cluster
    Ufull = cell(K,1);
    fullResids = zeros(N,K);
    for kk = 1:K
        kInds = find(estLabels==kk);
        Xk = X(:,kInds);
        [Ufull{kk},~,~] = svds(Xk,d);
        XkPerp = Xk - Ufull{kk}*(Ufull{kk}\Xk);
        ipMat(kInds,:) = XkPerp'*X;
        fullResids(:,kk) = norms(X - Ufull{kk}*(Ufull{kk}\X));
    end
else
    Ufull = state.Ufull;
    fullResids = state.fullResids;
    for kk = 1:K
        kInds = find(estLabels==kk);
        Xk = X(:,kInds);
        XkPerp = Xk - Ufull{kk}*(Ufull{kk}\Xk);
        ipMat(kInds,:) = XkPerp'*X;
    end
end

Dmat = zeros(N);
for ii = 1:N
    for jj = ii:N
        Dmat(ii,jj) = sqrt( abs( fullResids(ii,estLabels(ii))^2 + fullResids(ii,estLabels(jj))^2 + fullResids(jj,estLabels(ii))^2 + fullResids(jj,estLabels(jj))^2 - 2*abs(ipMat(ii,jj)) - 2*abs(ipMat(jj,ii)) ) ) / 2;
    end
end
Dmat = Dmat + Dmat' - 2*diag(diag(Dmat));
